//
// File: TermIO.h
// Created by: cc <(null)>
// Created on: Mon Sep 23 08:18:52 2002
//

#include "TermIO.h"

#define NAME_COLUMN 0
#define VAL_COLUMN 10

#define PRINT_NAME(s,l)   {move (l, NAME_COLUMN); printString (s);}
#define SET_AND_PRINT(n,x,l) {n = x; move (l, VAL_COLUMN); printDouble (n);}
#define SCALE_AND_PRINT(n,x,l) {n *= x; move (l, VAL_COLUMN); printDouble (n);}

#define COEFFA_LINE 1
#define COEFFF_LINE 2

TermIO::TermIO (bool eat_all_key_strokes)
{
	w = initscr ();		/* initialize the ncurses library */
	wtimeout (w, 0);
	noecho ();
	printw ("use `q' to quit\n");
	quit = false;
	chain = !eat_all_key_strokes;
	PRINT_NAME ("coeffA", COEFFA_LINE);
	PRINT_NAME ("coeffF", COEFFF_LINE);
	SET_AND_PRINT (coeffA, 1.0, COEFFA_LINE);
}


TermIO::~TermIO ()
{
	endwin ();
}

void
TermIO::printDouble (double d)
{
	printw ("%f", d);
}

void
TermIO::printString (char *s)
{
	printw ("%s", s);
}


void
TermIO::pollEvent ()
{
	switch (int key = getch ())
	{
	case 'q':
		quit = true;
		break;
	case 'a':
		SCALE_AND_PRINT (coeffA, 0.9, COEFFA_LINE);
		break;
	case 'A':
		SCALE_AND_PRINT (coeffA, 1.1, COEFFA_LINE);
		break;
	case 'f':
		SCALE_AND_PRINT (coeffF, 0.9, COEFFF_LINE);
		break;
	case 'F':
		SCALE_AND_PRINT (coeffF, 1.1, COEFFF_LINE);
		break;
	case '1':
		SET_AND_PRINT (coeffF, 1.0, COEFFF_LINE);
		break;
	case '2':
		SET_AND_PRINT (coeffF, 2.0, COEFFF_LINE);
		break;
	case '3':
		SET_AND_PRINT (coeffF, 3.0, COEFFF_LINE);
		break;
	case '4':
		SET_AND_PRINT (coeffF, 4.0, COEFFF_LINE);
		break;
	case '5':
		SET_AND_PRINT (coeffF, 5.0, COEFFF_LINE);
		break;
	case '6':
		SET_AND_PRINT (coeffF, 6.0, COEFFF_LINE);
		break;
	case '7':
		SET_AND_PRINT (coeffF, 7.0, COEFFF_LINE);
		break;
	case '8':
		SET_AND_PRINT (coeffF, 8.0, COEFFF_LINE);
		break;
	case '9':
		SET_AND_PRINT (coeffF, 9.0, COEFFF_LINE);
		break;
	case '0':
		SET_AND_PRINT (coeffF, 10.0, COEFFF_LINE);
		break;
	case ERR:
		break;
	default:
		if (chain)
			ungetch (key);	// to pass through unread keys
		break;
	}
}
